/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



template < class T_item > class Array;

#ifndef __Array_h__
#define __Array_h__


/**
   A dynamical array, more powerful than the simple [ ].
   @author David FAUTHOUX
 */
template < class T_item >
class Array {
 protected:
  ///Size
  const int s;
  ///Array (by 'new')
  T_item *p;
  ///
  bool haveToDelete;
 public:
  ///
  Array(int size) throw();
  ///
  Array(T_item *ref,int size) throw();
  ///
  ~Array() throw ();
  ///
  int size() const throw();
  ///
  T_item& operator[](int k) throw();
  ///
  const T_item& operator[](int k) const throw();
  ///Copies the array 'a'
  Array(const Array< T_item >& a) throw();

  ///Copies the array 'a'
  Array< T_item >& operator=(const Array< T_item >& a) throw();
  ///Fills the array with the item 'i'
  Array< T_item >& operator=(T_item i) throw();

  ///
  operator const T_item*() const throw () { return p; }

};

#include "Array.cc"

#endif


