/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



template<class T_item>
Array3<T_item>::
Array3(int deep_z,int nbLine_j,int nbColumn_i) throw ()
  :tab(deep_z)
{
  for(int k=0;k<deep();k++) tab[k]=new Array2<T_item>(nbLine_j,nbColumn_i);
}

template<class T_item>
Array3<T_item>::
~Array3() throw ()
{
  for(int k=0;k<deep();k++) delete tab[k];
}

template<class T_item>
Array3<T_item>::
Array3(const Array3<T_item>& m) throw ()
  :tab(m.deep())
{
  for(int k=0;k<deep();k++) tab[k]=new Array2<T_item>(m[k]);
}

template<class T_item>
Array3<T_item>& 
Array3<T_item>::
operator=(const Array3<T_item>& m) throw ()
{
  for(int k=0;k<deep();k++) delete tab[k];
  tab=m.tab;
  for(int k=0;k<deep();k++) tab[k]=new Array2<T_item>(m[k]);
  return *this;
}

template<class T_item>
Array2<T_item>& 
Array3<T_item>::
operator[](int k) throw ()
{
  return *tab[k];
}

template<class T_item>
const Array2<T_item>& 
Array3<T_item>::
operator[](int k) const throw ()
{
  return *tab[k];
}


template<class T_item>
int 
Array3<T_item>::
deep() const throw()
{
  return tab.size();
}

template<class T_item>
int 
Array3<T_item>::
nbLine() const throw()
{
  return tab[0]->nbLine();
}

template<class T_item>
int 
Array3<T_item>::
nbColumn() const throw()
{
  return tab[0]->nbColumn();
}

