/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "Bonhomme.h"
#include "Anim.h"
#include "LoopAnim.h"


Bonhomme::Bonhomme(Ini& ini,int numeroSection,
		   //		   FlashPalette& palette,
		   Sounder& sounder,
		   TextPainter& textPainter,
		   StripContainer& stripContainer) throw(Exception)
  :id(ini.get("[Bonhomme]",numeroSection,"id",0))
{

  bonhomme60=new Bonhomme60(ini,numeroSection,*this,
			    textPainter,
			    sounder,pixelPalette);
  bonhomme20=new Bonhomme20(ini,numeroSection,*this,
			    sounder,
			    textPainter,
			    stripContainer,
			    pixelPalette);

  setColor(toPixel(maxRedValue,maxGreenValue,maxBlueValue,0));
}

void Bonhomme::setColor(Pixel col) throw()
{
  color=col;
  int r=getRedFromPixel(col);
  int g=getGreenFromPixel(col);
  int b=getBlueFromPixel(col);
  for(int k=minGreyValue;k<maxGreyValue;k++)
    pixelPalette[toPixel(k,k,k,0)]=toPixel((r*k)/maxGreyValue,
					   (g*k)/maxGreyValue,
					   (b*k)/maxGreyValue,
					   0);
}


const String *Bonhomme::getId() const throw()
{
  return id;
}

Bonhomme::~Bonhomme() throw()
{
}

List<Bonhomme *> *Bonhomme::getPlayingAll() throw()
{
  return &playingAll;
}//renvoie aussi lui


List<Bonhomme *> *Bonhomme::getPlayingTeam() throw()
{
  return &playingTeam;
}//renvoie aussi lui

List<Bonhomme *> *Bonhomme::getPlayingExceptTeam() throw()
{
  return &playingExceptTeam;
}

void Bonhomme::addPlaying(Bonhomme& b,bool inTeam) throw()
{
  playingAll.put(&b);
  if(inTeam) playingTeam.put(&b);
  else playingExceptTeam.put(&b);
}//appele par le Container

void Bonhomme::supprAllPlayingAdded() throw()
{
  playingAll.place();
  while(playingAll.walk()) playingAll.suppr();
  playingTeam.place();
  while(playingTeam.walk()) playingTeam.suppr();
  playingExceptTeam.place();
  while(playingExceptTeam.walk()) playingExceptTeam.suppr();
}//appele par le Container qd equipe change


Bonhomme20 *Bonhomme::getBonhomme20() throw()
{
  return bonhomme20;
}

Bonhomme60 *Bonhomme::getBonhomme60() throw()
{
  return bonhomme60;
}
