/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class CCFileModifier;

#ifndef __CCFileModifier_h__
#define __CCFileModifier_h__

#include "TextFileModifier.h"


#define CC_FILE_MODIFIER_ERROR "Error while modifying .cc file"


/**
   Used for addon. It modify .cc files without killing comments of course !
   Modification can be suppressed restoring the file like before WITHOUT HAVING SAVED THE FILE !!!
   It is very difficult, but I think it works.
   @author David FAUTHOUX
 */
class CCFileModifier:public TextFileModifier {
 protected:
  ///
  const String *className;

  ///
  void message(const String& m) throw();

  ///
  String *simplifyAndCompleteDeclaration(const String& declaration,const String& completion) throw();

  ///
  bool auxCompleteFunctionAfter(const String& declaration,List<const String *>& body,List<const String *>& afterLines,const String& completion) throw();
  ///
  bool auxCompleteFunctionBefore(const String& declaration,List<const String *>& body,List<const String *>& beforeLines,const String& completion) throw();
  ///
  bool auxCompleteFunctionAtBeginning(const String& declaration,List<const String *>& body,const String& completion) throw();
  ///
  bool auxCompleteFunctionAtEnd(const String& declaration,List<const String *>& body,const String& completion) throw();


 public:
  ///
  CCFileModifier(const String& className,
		 List<const String *>& markList) throw(Exception);

  ///
  virtual ~CCFileModifier() throw();

  ///
  bool placeAtEnd() throw();

  bool placeAfterSharps() throw(); //diese #

  ///
  bool addInheritance(const String& motherClass,const String& init) throw();
  ///
  bool addParameter(const String& name,const String& init) throw();
  ///
  bool addFunction(const String& declaration,List<const String *>& body) throw();
  ///
  bool addFunctionTemplate(const String& classTemplate,const String& declaration,List<const String *>& body) throw();


  ///
  bool completeFunctionAfter(const String& declaration,List<const String *>& body,List<const String *>& afterLines) throw();
  ///
  bool completeFunctionBefore(const String& declaration,List<const String *>& body,List<const String *>& beforeLines) throw();
  ///
  bool completeFunctionAtBeginning(const String& declaration,List<const String *>& body) throw();
  ///
  bool completeFunctionAtEnd(const String& declaration,List<const String *>& body) throw();

  ///
  bool completeFunctionTemplateAfter(const String& classTemplate,const String& declaration,List<const String *>& body,List<const String *>& afterLines) throw();
  ///
  bool completeFunctionTemplateBefore(const String& classTemplate,const String& declaration,List<const String *>& body,List<const String *>& beforeLines) throw();
  ///
  bool completeFunctionTemplateAtBeginning(const String& classTemplate,const String& declaration,List<const String *>& body) throw();
  ///
  bool completeFunctionTemplateAtEnd(const String& classTemplate,const String& declaration,List<const String *>& body) throw();



  ///
  bool addDefine(const String& id,const String& value) throw();

  ///
  bool addInclude(const String& file) throw();

  /*%%
  ///
  bool findEnum(const String& enumName) throw();
  ///
  bool addInEnumAfter(const String& enumName,const String& id,List<const String *>& afterLines,List<const String *>& comment) throw();
  ///
  bool addInEnumBefore(const String& enumName,const String& id,List<const String *>& beforeLines,List<const String *>& comment) throw();
  ///
  bool addInEnumAtEnd(const String& enumName,const String& id,List<const String *>& comment) throw();
  */

  /*%%
  ///
  bool addSubclass(const String& protection,List< const String * >& wallDeclaration) throw();
  */

  ///
  bool addRoughlyAfter(List< const String * >& body,List< const String * >& afterLines) throw();
  ///
  bool addRoughlyBefore(List< const String * >& body,List< const String * >& beforeLines) throw();
  ///
  bool addRoughlyAtBeginning(List< const String * >& body) throw();
  ///
  bool addRoughlyAtEnd(List< const String * >& body) throw();

};

#endif


