/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "CaseBombe.h"


CaseBombe::CaseBombe(Anim *aniNormal,
		     Anim *aniFin,Bonhomme20 *poseur,
		     Sounder& sounder,int soundId) throw()
  :puissance(0),traverseMur(false),
   aniNormalId(add(*aniNormal)),
   aniFinId(add(*aniFin)),step(0),
   bonhomme(poseur),
   sounderRef(&sounder),soundIdRef(soundId)
{
  if(bonhomme) {
    puissance=bonhomme->getPuissance();
    traverseMur=bonhomme->isSuperBombe();
  }
}
bool CaseBombe::toBeBlownUp() const throw()
{
  if(step==2) return true;
  return false;
}

int CaseBombe::virtualWalk() throw() 
{
  if(!MultiAnim::virtualWalk()) {
    if(step==0) {
      sounderRef->play(soundIdRef);
      on(aniFinId);
      if(bonhomme) bonhomme->decNbPose();
    }
    step++;
  }
  if(step==2) return 0;
  else return 1;
}

bool CaseBombe::blowable() throw()
{
  if(step==0) {
    sounderRef->play(soundIdRef);
    on(aniFinId);
    step=1;
    if(bonhomme) bonhomme->decNbPose();
    return true;
  }
  return false;
}
bool CaseBombe::getTraverseMur() const throw() { return traverseMur; }
int CaseBombe::getPuissance() const throw() { return puissance; }

bool CaseBombe::restricted() const throw()
{
  if(step==1) return true;
  return false;
}

bool CaseBombe::stackable() const throw() { return false; }

bool CaseBombe::traversable(bool) throw() { return true; }


void CaseBombe::paintNight(WindowPipe&windowPipe)throw()
{
paint(windowPipe);
}
