/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class CaseGestion;

#ifndef __CaseGestion_h__
#define __CaseGestion_h__

#include "Case.h"

#include "Ini.h"
#include "Sounder.h"
#include "Grille.h"
#include "Bonhomme20.h"
#include "Anim.h"
#include "CaseId.h"
#include "Femme.h"

// 'CaseGestion' cree a son initialisation toutes les cases possibles,
// ensuite, lorsqu'on lui demande de creer une case ('get'), il lui suffit
// de cloner l'animation correspondante ('Anim(const Anim& a)') en creant la
// case.

/**
   This class is very important : it create before gaming all the animations (loading files), so when the game want to create an animation, it only does a copy (quicker). It manages all the Case. It is created by Grille.
   @see Case
   @see Grille
   @author David FAUTHOUX
 */
class CaseGestion {
 protected:

  ///
  Sounder *const sounderRef;
  ///
  int soundBombeId;
  ///
  int soundArmageddonId;
  ///
  int soundArmageddonBlowUpId;
  ///
  int soundPhotoId;
  ///
  int soundFlashId;
  ///
  int soundChickenId;
  ///
  int soundChickenEndId;
  ///
  int soundFemmeId;
  ///
  int soundOubaId;
  ///
  int soundResurrectId;
  ///
  int soundWin95Id;

  ///
  List< Anim* > allAnim[CaseId::NB_ALL];

  ///
  int oldToBeKept;

  ///
  Femme *const femmeRef;

  ///
  virtual void setAnim(Ini& ini,int numeroSection,CaseId::Id animId,const String& id) throw(Exception);
  ///
  virtual Anim *findIt(CaseId::Id animId,bool loop,int cpt) throw();
  ///
  virtual Anim *find(CaseId::Id animId,bool loop=false) throw(Exception);
  ///
  virtual Anim *findK(CaseId::Id animId,bool loop=false) throw(Exception);


 public:
  ///
  CaseGestion(Ini& ini,int numeroSection,Sounder& sounder,Femme& femme) throw(Exception);
  ///
  virtual ~CaseGestion() throw();
  ///
  virtual Case *get(CaseId::Id id,Grille& grille,Bonhomme20 *bonhommeQuiPose) throw(Exception);
  //cree la case //clone l'anim

  ///
  virtual int getSoundBombeId() const throw();

};

#endif
