/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class CaseMine;

#ifndef __CaseMine_h__
#define __CaseMine_h__

#include "CaseBombe.h"

/**
   The mine Case.
   @author David FAUTHOUX
 */
class CaseMine:public CaseBombe {
 public:
  /**
     Defines entirely the Case : the animations used, the bonhomme who has put the bomb, the Sounder wich manages sounds.
     @param aniNormal the animation while doing nothing
     @param aniFin the animation just before blowing
     @param poseur the bonhomme who has put the mine
     @param sounder the Sounder wich manages sounds
     @param soundId the id for the sound to be played (given by the Sounder when sound loaded)
   */
  CaseMine(Anim *aniNormal,
	   Anim *aniFin,
	   Bonhomme20 *poseur,Sounder& sounder,int soundId) throw();

  ///
  ~CaseMine() throw() {}

  /**
     Hoops ! There is a problem when the bonhomme walks on (if he isn't the putter of this mine) !
     @param bonhomme the bonhomme who performs the action (blow !)
   */
  virtual void action(Bonhomme20& bonhomme) throw();

  ///
  virtual void paintNight(WindowPipe& windowPipe) throw();
};

#endif

