/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "CaseMurDestructible.h"


CaseMurDestructible::CaseMurDestructible(Anim *aniNormal,Anim *aniBrise,
					 Anim *aniTas,Anim *aniEnvole) throw()
  :aniNormalId(add(*aniNormal)),
   aniBriseId(add(*aniBrise)),
   aniTasId(add(*aniTas)),
   aniEnvoleId(add(*aniEnvole)),
   step(0)
{
}

bool CaseMurDestructible::traversable(bool force) throw()
{
  switch(step) {
  case 0:
    if(force) {
      on(aniBriseId);
      activateUnder=true;
      step=1;
      return true;
    }
    return false;
  case 2:
    on(aniEnvoleId);
    step=3;
    return true;
  default:
    return true;
  }
}

int CaseMurDestructible::virtualWalk() throw()
{
  if(!MultiAnim::virtualWalk()) {
    if(step==1) on(aniTasId);
    step++;
  }
  if(step==4) return 0;
  return 1;
}

bool CaseMurDestructible::blowable() throw()
{
  switch(step) {
  case 0:
    on(aniBriseId);
    activateUnder=true;
    step=1;
    return true;
  case 2:
    on(aniEnvoleId);
    step=3;
    return false;
  default:
    return false;
  }
}

void CaseMurDestructible::action(Bonhomme20& bonhomme) throw()
{
  if(step==0) bonhomme.setUpNiv();
}

bool CaseMurDestructible::stackable() const throw()
{
  if(step==0) return false;
  return true;
}
bool CaseMurDestructible::high() const throw()
{
  if(step==0) return true;
  return false;
}



