/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class CaseMurIndestructible;

#ifndef __CaseMurIndestructible_h__
#define __CaseMurIndestructible_h__

#include "Case.h"

/**
   The indestructible wall Case.
   It never breaks down. It is high. When a bonhomme walks on, he is on the high level.
   @author David FAUTHOUX
   @see Sounder
   @see Bonhomme20
   @see Anim
 */
class CaseMurIndestructible:public Case {
 public:
  /**
     Nothing.
   */
  CaseMurIndestructible() throw();
  ///
  ~CaseMurIndestructible() throw() {}
  /**
     Ups the bonhomme.
   */
  virtual void action(Bonhomme20& bonhomme) throw();//nivUp
  /**
     Never.
   */
  bool virtual traversable(bool force) throw();
  /**
     Never.
   */
  bool stackable() const throw();//false
  /**
     Always.
   */
  bool high() const throw();//true
};

#endif

