/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "CaseOption.h"


CaseOption::CaseOption(Anim *aniNormal,Anim *aniCrame) throw()
  /*    aniNormal!=0 => aniCrame!=0 */
  :step(0),got(false),sol(false)
{
  if(!aniNormal) sol=true;
  else {
    aniNormalId=add(*aniNormal);
    aniCrameId=add(*aniCrame);
    step=0;
  }
}

int CaseOption::virtualWalk() throw()
{
  if(sol) return 1;
  if(got) return 0;
  if(!MultiAnim::virtualWalk()) {
    step=2;
    return 0;
  }
  return 1;
}

void CaseOption::action(Bonhomme20& bonhomme) throw()
{
  if(sol || !got) {
    if(bonhomme.capableToTakeOption()) {
      got=true;
      derivedAction(bonhomme);
    }
  }
}
bool CaseOption::blowable() throw()
{
  if(sol || got) return false;
  if(step==0) {
    on(aniCrameId);
    step=1;
    return true;
  }
  return false;
}


bool CaseOption::paintedUp() throw()
{
  return true;
}
