/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class CaseOption;

#ifndef __CaseOption_h__
#define __CaseOption_h__

#include "Case.h"

/**
   When creating an option, you must re-defined (inherite) derivedAction() called by the mother class (this).
   @see CaseGestion
   @author David FAUTHOUX
 */
class CaseOption:public Case {
 protected:
  ///
  int aniNormalId;
  ///
  int aniCrameId;
  ///
  int step;
  ///
  bool got;
  ///
  bool sol;
  ///
  virtual void derivedAction(Bonhomme20& bonhomme) throw(Exception)=0;
 public:
  ///
  CaseOption(Anim *aniNormal,Anim *aniCrame) throw();
  //ani==0 => sol

  ///
  ~CaseOption() throw() {}

  ///
  int virtual virtualWalk() throw();
  ///
  virtual void action(Bonhomme20& bonhomme) throw();

  ///
  bool virtual blowable() throw(); //if(ani!=0)... step=0 => on(Crame)

  /**
     @return true
   */
  bool virtual paintedUp() throw();
};

#endif

