/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "CaseOptionCounter.h"


CaseOptionCounter::CaseOptionCounter(Anim *aniNormal,Anim *aniCrame,
				     Sounder& sounder,
				     int soundId,int soundEndId) throw()
  :CaseOption(aniNormal,aniCrame),
   sounderRef(&sounder),
   soundIdRef(soundId),
   soundEndIdRef(soundEndId),
   blowed(false),
   bonhommeRef(0)
{
}
void CaseOptionCounter::derivedAction(Bonhomme20& b) throw(Exception)
{
  if(bonhommeRef!=&b) {
    bonhommeRef=&b;
    if(soundIdRef>=0)
      CounterContainer::add(sounderRef->play(soundIdRef),0);
  }
}
int CaseOptionCounter::virtualWalk() throw()
{
  inc();
  if(sol) return 1;
  if(blowed) return 0;
  if(!MultiAnim::virtualWalk()) {
    step=2;
    return 0;
  }
  return 1;
}
void CaseOptionCounter::endOfCount(int value) throw()
{
  blowed=true;
  if(soundEndIdRef>=0) sounderRef->play(soundEndIdRef);
  if(bonhommeRef) derivedEnd(*bonhommeRef);
  bonhommeRef=0;
}
void CaseOptionCounter::paint(WindowPipe& windowPipe) throw()
{
  if(!got) CaseOption::paint(windowPipe);
}
void CaseOptionCounter::action(Bonhomme20& bonhomme) throw()
{
  if(sol || !got) {
    if(bonhomme.capableToTakeOption(false)) {
      got=true;
      derivedAction(bonhomme);
    }
  }
}




