/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class CaseOptionCounter;

#ifndef __CaseOptionCounter_h__
#define __CaseOptionCounter_h__

#include "CaseOption.h"
#include "CounterContainer.h"
#include "Exception.h"

/**
   It manages a time counter, to delay an action (it calls derivedEnd() at the end of the sound references by soundEndIdRef)
   @author David FAUTHOUX
 */
class CaseOptionCounter:public CaseOption,public CounterContainer {
 protected:
  ///
  Sounder *const sounderRef;
  ///
  const int soundIdRef;
  ///
  const int soundEndIdRef;
  ///
  bool blowed;
  ///
  Bonhomme20 *bonhommeRef;

  ///
  int virtual virtualWalk() throw();
  ///
  virtual void endOfCount(int value) throw();
  ///
  virtual void derivedEnd(Bonhomme20& b) throw(Exception)=0;
  ///
  virtual void derivedAction(Bonhomme20& bonhomme) throw(Exception);
 public:
  ///
  CaseOptionCounter(Anim *aniNormal,Anim *aniCrame,
		    Sounder& sounder,int soundId,int soundEndId) throw();
  ///
  ~CaseOptionCounter() throw() {}
  ///
  virtual void paint(WindowPipe& windowPipe) throw();
  ///
  virtual void action(Bonhomme20& bonhomme) throw();
};

#endif

