/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "CaseOptionFemme.h"


CaseOptionFemme::CaseOptionFemme(Anim *aniNormal,Anim *aniCrame,
				 Grille& g,
				 Sounder& sounder,int soundId,
				 Femme& femme) throw()
  :CaseOption(aniNormal,aniCrame),
   sounderRef(&sounder),
   soundIdRef(soundId),
   blowed(false),
   grille(&g),
   femme(&femme)
{
}

void CaseOptionFemme::derivedAction(Bonhomme20& b) throw()
{
  femme->reinit();
  femme->activate();
  bonhommeRef=&b;
  if(soundIdRef>=0) sounderRef->play(soundIdRef);
  if(!sol) b.printStrip(PreStrip::CASE_OPTION_FEMME);
}

int CaseOptionFemme::virtualWalk() throw()
{
  if(blowed) return 0;
  if(got && !femme->isActive()) {
    blowed=true;
    if(bonhommeRef) grille->runFemme(*bonhommeRef);
    return 0;
  }
  if(sol) return 1;
  if(!MultiAnim::virtualWalk()) {
    step=2;
    return 0;
  }
  return 1;
}

void CaseOptionFemme::paint(WindowPipe& windowPipe) throw()
{
  if(!got) CaseOption::paint(windowPipe);
}

void CaseOptionFemme::action(Bonhomme20& bonhomme) throw()
{
  if(sol || !got) {
    if(bonhomme.capableToTakeOption(false)) {
      got=true;
      derivedAction(bonhomme);
    }
  }
}



