/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



//Describe the convention to pass when writting c++ codes

class Convention; //All class name must have a capital letter in first

//Only ONE class per file

#ifndef __Convention_h__ //__ClassName_h__
#define __Convention_h__ //__ClassName_h__

//Includes and Defines here
#include "MotherClass.h"
#include "File.h"
#define ID VALUE 

///The class MUST be preceded with comments with THREE slashes (or /** ... */ with TWO stars), so we can use doc++ which generate automatically HTML files
class Convention:public MotherClass {
  //Only declarations here, definitions should be in className.cc file
 protected:

  /**
   */
  Type param1;

  /**
   */
  Type param2;

 public:

  ///Every parameters and functions MUST be preceded with comments with THREE slashes (or /** ... */ with TWO stars), so we can use doc++ which generate automatically HTML files
  Convention(Type1 param1,Type2 param2=initialisation) throw(Exception);//All functions must be declared with throw(...) - generally here 'throw(Exception)' or 'throw()'


  /**
     The comments can content HTML macros (for example <i> ... <\i> or @author or @see)
   */
  virtual ~Convention() throw();//The destructor must be declared virtual, so others virtual functions can be added later


  /**
     COMMENT !
   */
  virtual int function() throw();//All methods (functions) should be declared virtual, except for special cases

};


//Remember : Only ONE class per file !

#endif

