/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "CounterContainer.h"

void CounterContainer::inc() throw()
{
  List<Counter *> l=list;
  List<Counter *> toD;
  l.place();
  while(l.walk())
    if(!l.get()->walk()) toD.put(l.get());

  toD.place();
  while(toD.walk()) {
    list.place();
    while(list.walk())
      if(list.get()==toD.get()) {
	delete list.get();
	list.suppr();
	break;
      }
  }
}

CounterContainer::CounterContainer() throw() {}

CounterContainer::~CounterContainer() throw()
{
  list.place();
  while(list.walk()) delete list.get();
}

void CounterContainer::supprIfPresent(int value) throw()
{
  list.place();
  while(list.walk())
    if(list.get()->getValue()==value) {
      delete list.get();
      list.suppr();
      break;
    }
}

void CounterContainer::add(int t,int value) throw()
{
  supprIfPresent(value);
  list.put(new Counter(t,value,*this));
}

void CounterContainer::addLoop(int t,int value) throw()
{
  supprIfPresent(value);
  list.put(new LoopCounter(t,value,*this));
}

void CounterContainer::reset() throw()
{
  list.place();
  while(list.walk()) {
    delete list.get();
    list.suppr();
  }
}



