#include <stdlib.h>
#include "Femme.h"
#include "LoopAnim.h"

#define DEFAULT_SLOW_ANIMATION 5

#define DEFAULT_POS_FEMME_J 0
#define DEFAULT_POS_FEMME_I 0


int Femme::virtualWalk() throw()
{
  if(animCurrent) animCurrent->walk();
  if(!anim->walk()) {
    unactivate();
    return 0;
  }
  return 1;
}

Femme::Femme(Ini& ini) throw()
  :Pageable(0),
   iniRef(&ini),
   anim(new Anim(*ini.get("[Woman]",0,"anim",0),
		 ini.getWithDefault("[Woman]",0,"slow",0,
				    DEFAULT_SLOW_ANIMATION),
		 ini.getListSeparator()))
{
  anim->setTo();
  int jPosFemme=ini.getWithDefault("[Woman]",0,"pos j",0,
				   DEFAULT_POS_FEMME_J);
  int iPosFemme=ini.getWithDefault("[Woman]",0,"pos i",0,
				   DEFAULT_POS_FEMME_I);
  anim->move(jPosFemme,iPosFemme);

  List<const String *> *l=ini.getListWithoutException("[Woman]",0,"dress");
  if(l) {
    l->place();
    int cpt=0;
    while(l->walk()) {
      try {
	Anim *a=new LoopAnim(*(l->get()),
			     ini.getWithDefault("[Woman]",0,
						"dress slow",cpt,
						DEFAULT_SLOW_ANIMATION),
			     ini.getListSeparator());
	
	a->setTo();
	a->move(jPosFemme,iPosFemme);
	List< int > *command=ini.getWithDefaultKeyList("[Woman]",0,"dress command",cpt,"dresswoman");

	dress.place();
	bool found=false;
	while(dress.walk()) {
	
	  List< int > *cmp=&dress.get()->s;

	  bool id=true;

	  cmp->place();
	  command->place();
	  while(cmp->walk()) {
	    if(!command->walk()) id=false;
	    if(cmp->get()!=command->get()) id=false;
	  }
	  if(command->walk()) id=false;

	  /*
	    command->place();
	    while(command->walk()) cout<<command->get()<<".";
	    cout<<"\n";cout.flush();
	    dress.get()->s.place();
	    while(dress.get()->s.walk()) cout<<dress.get()->s.get()<<".";
	    cout<<"\n";cout.flush();
	    cout<<"?";
	    if(beurk.equal(*command)) cout<<"O";
	    else cout<<"N";
	    cout<<"\n";cout.flush();
	    if((dress.get()->s).equal(*command)) {
	  */

	  if(id) {
	    dress.get()->l.put(a);
	    found=true;
	    break;
	  }
	}

	if(!found) {
	  message(*command,dress.length());
	  dress.placeCurrentOnHead();
	  dress.put(new AssocListIntListAnim(*command,*a));
	}
      } catch(Exception) {}
      
      cpt++;
    }
  }
  if(!dress.empty()) {
    int cpt=ini.getWithDefault("[Woman]",0,"dress current",0,0);
    if(cpt>=0 && cpt<dress.length()) dressCurrent=cpt;
    else dressCurrent=0;

    animCurrent=dress[dressCurrent]->l.getRandomly();
  }
}


Femme::~Femme() throw()
{
  dress.place();
  while(dress.walk()) {
    List< Anim * > *l=&dress.get()->l;
    l->place();
    while(l->walk()) delete l->get();
    delete dress.get();
  }

  iniRef->set("[Woman]",0,"dress current",0,dressCurrent);
}


void Femme::paint(WindowPipe& windowPipe) throw()
{
  anim->paint(windowPipe);
  if(animCurrent) animCurrent->paint(windowPipe);
}

void Femme::reinit() throw()
{
  if(dress.empty()) animCurrent=0;
  else animCurrent=dress[dressCurrent]->l.getRandomly();

  if(animCurrent) animCurrent->reinit();
  anim->reinit();
}

void Femme::keyAction(const Key& key) throw()
{
  work(key);
}

void Femme::action(int idAction) throw()
{
  dressCurrent=idAction;
}

