/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "error.h"

template <class T_item>
int
Fifo<T_item>::
empty() const throw ()
{
  return List<T_item>::empty();
}

template <class T_item>
T_item
Fifo<T_item>::
get() throw (Exception)
{
  if(List<T_item>::empty()) throw Exception(ERROR_FIFO_EMPTY);
  List<T_item>::place();
  List<T_item>::walk();
  T_item t=List<T_item>::get();
  List<T_item>::suppr();
  return t;
}

template <class T_item>
void
Fifo<T_item>::
put(T_item item) throw ()
{
  //      while(List<T_item>::walk());
  placeCurrentOnHead();
  List<T_item>::put(item);
}


