/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "FlashPalette.h"

#define DEFAULT_FLASH_SLOW 10


FlashPalette::FlashPalette(Ini& ini,GraphicMode& graphicMode) throw()
  :Walkable(ini.getWithDefault("[Slow]",0,"flash",0,DEFAULT_FLASH_SLOW)),
   underMask(graphicMode.nbLine(),graphicMode.nbColumn()),
   pixelMatrix(graphicMode.nbLine(),graphicMode.nbColumn()),
   windowFrom(pixelMatrix),
   windowTo(graphicMode),
   windowPipe(windowTo,windowFrom,underMask),
   flashing(false),flashed(FLASHING_TO_COLOR)
{
  for(int j=0;j<pixelMatrix.nbLine();j++)
    for(int i=0;i<pixelMatrix.nbColumn();i++)
      pixelMatrix[j][i]=toPixel(maxGreyValue,maxGreyValue,maxGreyValue,0);
}

FlashPalette::~FlashPalette() throw()
{
}

void FlashPalette::flashToGris() throw()
{
  //TROP LENT, TOO SLOW !!! (+ bug with putSpriteUnderMask => not interesting !!
  //  flashed=FLASHING_TO_GRIS;
  flashed=FLASHING_TO_COLOR;
  flashing=true;
  t=s;
}

void FlashPalette::flashToColor() throw()
{
  flashed=FLASHING_TO_COLOR;
  flashing=true;
  t=s;
}

void FlashPalette::flashToOther() throw()
{
  if(flashed==FLASHING_TO_COLOR) flashed=FLASHING_TO_COLOR;//TOO SLOW !! FLASHING_TO_GRIS;
  else flashed=FLASHING_TO_COLOR;
  flashing=true;
  t=s;
}

bool FlashPalette::isGris() const throw()
{
  return pixelGrey;
}


void FlashPalette::refresh() throw()
{
  if(flashing)
    windowPipe.refreshAll();
}

int FlashPalette::virtualWalk() throw()
{
  flashing=false;
  if(flashed==FLASHING_TO_GRIS) pixelGrey=true;
  else pixelGrey=false;
  return 1;
}
