/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */




class Key;

#ifndef __Key_h__
#define __Key_h__

#include "SDL.h"

// Utilise par 'Keyer'

/**
   @see Keyer
   @see Keyable
   @author David FAUTHOUX
 */

  static const int BACKSPACE=SDLK_BACKSPACE;
  static const int TAB=SDLK_TAB;
  static const int CLEAR=SDLK_CLEAR;
  static const int RETURN=SDLK_RETURN;
  static const int PAUSE=SDLK_PAUSE;
  static const int ESCAPE=SDLK_ESCAPE;
  static const int SPACE=SDLK_SPACE;
  static const int EXCLAIM=SDLK_EXCLAIM;
  static const int QUOTEDBL=SDLK_QUOTEDBL;
  static const int HASH=SDLK_HASH;
  static const int DOLLAR=SDLK_DOLLAR;
  static const int AMPERSAND=SDLK_AMPERSAND;
  static const int QUOTE=SDLK_QUOTE;
  static const int LEFTPAREN=SDLK_LEFTPAREN;
  static const int RIGHTPAREN=SDLK_RIGHTPAREN;
  static const int ASTERISK=SDLK_ASTERISK;
  static const int PLUS=SDLK_PLUS;
  static const int COMMA=SDLK_COMMA;
  static const int MINUS=SDLK_MINUS;
  static const int PERIOD=SDLK_PERIOD;
  static const int SLASH=SDLK_SLASH;
  static const int K0=SDLK_0;
  static const int K1=SDLK_1;
  static const int K2=SDLK_2;
  static const int K3=SDLK_3;
  static const int K4=SDLK_4;
  static const int K5=SDLK_5;
  static const int K6=SDLK_6;
  static const int K7=SDLK_7;
  static const int K8=SDLK_8;
  static const int K9=SDLK_9;
  static const int COLON=SDLK_COLON;
  static const int SEMICOLON=SDLK_SEMICOLON;
  static const int LESS=SDLK_LESS;
  static const int EQUALS=SDLK_EQUALS;
  static const int GREATER=SDLK_GREATER;
  static const int QUESTION=SDLK_QUESTION;
  static const int AT=SDLK_AT;
  static const int LEFTBRACKET=SDLK_LEFTBRACKET;
  static const int BACKSLASH=SDLK_BACKSLASH;
  static const int RIGHTBRACKET=SDLK_RIGHTBRACKET;
  static const int CARET=SDLK_CARET;
  static const int UNDERSCORE=SDLK_UNDERSCORE;
  static const int BACKQUOTE=SDLK_BACKQUOTE;
  static const int A=SDLK_a;
  static const int B=SDLK_b;
  static const int C=SDLK_c;
  static const int D=SDLK_d;
  static const int E=SDLK_e;
  static const int F=SDLK_f;
  static const int G=SDLK_g;
  static const int H=SDLK_h;
  static const int I=SDLK_i;
  static const int J=SDLK_j;
  static const int K=SDLK_k;
  static const int L=SDLK_l;
  static const int M=SDLK_m;
  static const int N=SDLK_n;
  static const int O=SDLK_o;
  static const int P=SDLK_p;
  static const int Q=SDLK_q;
  static const int R=SDLK_r;
  static const int S=SDLK_s;
  static const int T=SDLK_t;
  static const int U=SDLK_u;
  static const int V=SDLK_v;
  static const int W=SDLK_w;
  static const int X=SDLK_x;
  static const int Y=SDLK_y;
  static const int Z=SDLK_z;
  static const int DELETE=SDLK_DELETE;
  static const int KP0=SDLK_KP0;
  static const int KP1=SDLK_KP1;
  static const int KP2=SDLK_KP2;
  static const int KP3=SDLK_KP3;
  static const int KP4=SDLK_KP4;
  static const int KP5=SDLK_KP5;
  static const int KP6=SDLK_KP6;
  static const int KP7=SDLK_KP7;
  static const int KP8=SDLK_KP8;
  static const int KP9=SDLK_KP9;
  static const int KP_PERIOD=SDLK_KP_PERIOD;
  static const int KP_DIVIDE=SDLK_KP_DIVIDE;
  static const int KP_MULTIPLY=SDLK_KP_MULTIPLY;
  static const int KP_MINUS=SDLK_KP_MINUS;
  static const int KP_PLUS=SDLK_KP_PLUS;
  static const int KP_ENTER=SDLK_KP_ENTER;
  static const int KP_EQUALS=SDLK_KP_EQUALS;
  static const int UP=SDLK_UP;
  static const int DOWN=SDLK_DOWN;
  static const int RIGHT=SDLK_RIGHT;
  static const int LEFT=SDLK_LEFT;
  static const int INSERT=SDLK_INSERT;
  static const int HOME=SDLK_HOME;
  static const int END=SDLK_END;
  static const int PAGEUP=SDLK_PAGEUP;
  static const int PAGEDOWN=SDLK_PAGEDOWN;
  static const int F1=SDLK_F1;
  static const int F2=SDLK_F2;
  static const int F3=SDLK_F3;
  static const int F4=SDLK_F4;
  static const int F5=SDLK_F5;
  static const int F6=SDLK_F6;
  static const int F7=SDLK_F7;
  static const int F8=SDLK_F8;
  static const int F9=SDLK_F9;
  static const int F10=SDLK_F10;
  static const int F11=SDLK_F11;
  static const int F12=SDLK_F12;
  static const int F13=SDLK_F13;
  static const int F14=SDLK_F14;
  static const int F15=SDLK_F15;
  static const int NUMLOCK=SDLK_NUMLOCK;
  static const int CAPSLOCK=SDLK_CAPSLOCK;
  static const int SCROLLOCK=SDLK_SCROLLOCK;
  static const int RSHIFT=SDLK_RSHIFT;
  static const int LSHIFT=SDLK_LSHIFT;
  static const int RCTRL=SDLK_RCTRL;
  static const int LCTRL=SDLK_LCTRL;
  static const int RALT=SDLK_RALT;
  static const int LALT=SDLK_LALT;
  static const int RMETA=SDLK_RMETA;
  static const int LMETA=SDLK_LMETA;
  static const int LSUPER=SDLK_LSUPER;
  static const int RSUPER=SDLK_RSUPER;
  static const int MODE=SDLK_MODE;
  static const int HELP=SDLK_HELP;
  static const int PRINT=SDLK_PRINT;
  static const int SYSREQ=SDLK_SYSREQ;
  static const int BREAK=SDLK_BREAK;
  static const int MENU=SDLK_MENU;
  static const int POWER=SDLK_POWER;
  static const int EURO=SDLK_EURO;


class Key {
 public:
  ///
  enum Evenement {
    ///
    UP,
    ///
    DOWN
  };
 private:
  ///
  const int code;
  ///
  const Evenement evenement;
 public:

  ///
  Key(int c,Evenement e) throw():code(c),evenement(e) {}
  ///
  ~Key() throw() {}
  ///Scancode (raw)
  int getCode() const throw() { return code; }
  ///If released
  bool isUp() const throw() { return (evenement==UP); }
  ///If pressed
  bool isDown() const throw() { return (evenement==DOWN); }
};

#endif
