/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "KeyboardBuffer.h"


KeyboardBuffer::KeyboardBuffer(bool _withoutRepeat) 
  throw (Exception)
  :withoutRepeat(_withoutRepeat)
{
    
  while(!buf.empty()) delete buf.get();
  downList.place();
  while(downList.walk()) downList.suppr();

  //%%  keyboard_seteventhandler(keyInBuffer);
}

Key *KeyboardBuffer::get() throw ()
{
  if(buf.empty()) return 0;
  return buf.get();
}

KeyboardBuffer::~KeyboardBuffer() throw ()
{}


void KeyboardBuffer::work(int key,bool press) throw()
{
  if (!press) {
    if(withoutRepeat) {
      downList.place();
      while(downList.walk()) if(downList.get()==key) downList.suppr();
      buf.put(new Key(key,Key::UP));
      downList.place();
      while(downList.walk()) buf.put(new Key(downList.get(),Key::DOWN));
    }
    else buf.put(new Key(key,Key::UP));
  }
  else {
    if(withoutRepeat) {
      downList.place();
      bool present=false;
      while(downList.walk() && !present) if(downList.get()==key) present=true;
      if(!present) {
	downList.put(key);
	buf.put(new Key(key,Key::DOWN));
      }
    }
    else {
      buf.put(new Key(key,Key::DOWN));
    }
  }
}

