/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class Leaver;

#ifndef __Leaver_h__
#define __Leaver_h__

#include "Walkable.h"
#include "CaseId.h"
#include "Bonhomme20.h"
#include "Grille.h"
#include "Tji.h"

// un 'Leaver' est un deposeur d'animations (de cases) sur la grille
// relativement au deplacement du bonhomme associe
// (par exemple : une case quittee implique le depot d'une flamme)

/**
   Manages the "lay down" of animations for the Bonhomme20 (example : invincible), easily !!
   It leaves animations on the Grille, that's because the animations left match to the squares.
   @see Bonhomme20
   @author David FAUTHOUX
 */
class Leaver:public Walkable {
 protected:
  ///
  Bonhomme20 *const bonhommeRef;
  ///
  const CaseId::Id idC;
  ///
  Grille *const grilleRef;

  ///
  Tji pos[4];

  ///
  virtual int virtualWalk() throw();
 public:
  ///
  Leaver(Bonhomme20& b,CaseId::Id c,Grille& grille) throw();
  ///
  virtual ~Leaver() throw();
  ///Put Case
  virtual CaseId::Id getCase() const throw();
};

#endif
