/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



template < class T_item > class List;

#ifndef __List_h__
#define __List_h__

#include "Exception.h"

/**
   Be careful: to simplify, this list is strange ! The place() places the current pointer out of the list, and you must do walk() before get(). It looks strange, but now, you can write easily : list.place(); while(list.walk()) ...list.get();
   Also, this form avoids some problem like the suppress : you can write easily : list.place(); while(list.walk()) list.suppr();
   Be careful : prefer pointer for template class T_item (list< MyClass * >)
   @author David FAUTHOUX
 */
template < class T_item >
class List {
 protected:
  ///
  struct Cell {
    ///
    T_item item;
    ///
    struct Cell *next;
    ///
    struct Cell *last;
  };
  ///
  Cell *head;
  ///
  Cell *queue;
  ///
  Cell *cur; //cur==0 => onQueue

  ///Length
  int l;

 public:

  ///
  List() throw ();
  ///
  virtual ~List() throw ();
  ///
  List(List< T_item >& from) throw ();
  ///
  virtual void put(T_item item) throw ();// avant cur
  ///
  //virtual T_item get() const throw (Exception);
  virtual T_item get() const throw ();
  ///
  virtual void suppr() throw ();

  ///PlaceCurrentOnQueue()
  virtual void place() throw ();//currentOnQueue
  ///walk until k
  virtual void place(int k) throw ();

  ///WalkQueueToHead, return 0 if cannot
  virtual int walk() throw ();//QueueToHead //0:ok, 1:deja on head

  ///
  virtual int empty() const throw ();


  ///
  virtual void placeCurrentOnHead() throw ();
  ///
  virtual int walkHeadToQueue() throw ();

  ///
  virtual void placeCurrentOnQueue() throw () { place(); }
  ///
  virtual int walkQueueToHead() throw () { return walk(); }

  ///Copy all the items
  virtual List< T_item >& operator=(List< T_item >& from) throw ();

  ///
  virtual bool equal(List< T_item >& from) throw ();


  ///
  virtual bool atTheQueue() const throw();
  ///
  virtual bool atTheHead() const throw();


  ///
  virtual int length() const throw();

  ///
  virtual T_item getRandomly() throw ();


  ///
  T_item operator[](int k) throw();
};

#include "List.cc"

#endif




