/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



/*
  Code of my friend Ulrich ROISSARD - 1999
 */

class MatriceTrans;

#ifndef __MatriceTrans_h__
#define __MatriceTrans_h__

#include <math.h>
#include "Matrice.h"

///
class MatriceTrans : public Matrice {

 public:
  ///
  MatriceTrans() throw() {
    setIdentity();
  }

  ///
  MatriceTrans(const Matrice &m) throw() : Matrice(m) {
  }

  ///
  ~MatriceTrans() throw() {}

/*
  ///
  Matrice &operator()(const MatriceTrans &m) throw() {
    mat=m.mat;
    return *this;
  }
*/
  ///
  MatriceTrans &rotateX(float alpha) throw() {
    MatriceTrans tmp;
    MatriceTrans current(*this);

    alpha=(alpha*M_PI)/180.0;
    tmp.get(0,0)=1;
    tmp.get(1,1)=cos(alpha);
    tmp.get(2,1)=-sin(alpha);
    tmp.get(1,2)=sin(alpha);
    tmp.get(2,2)=cos(alpha);

    *this=tmp*current;
    return *this;
  }

  ///
  MatriceTrans &rotateY(float alpha) throw() {
    MatriceTrans tmp;
    MatriceTrans current(*this);

    alpha=(alpha*M_PI)/180.0;
    tmp.get(1,1)=1;
    tmp.get(0,0)=cos(alpha);
    tmp.get(2,0)=-sin(alpha);
    tmp.get(0,2)=sin(alpha);
    tmp.get(2,2)=cos(alpha);

    *this=tmp*current;
    return *this;
  }

  ///
  MatriceTrans &rotateZ(float alpha) throw() {
    MatriceTrans tmp;
    MatriceTrans current(*this);

    alpha=(alpha*M_PI)/180.0;
    tmp.get(2,2)=1;
    tmp.get(0,0)=cos(alpha);
    tmp.get(1,0)=-sin(alpha);
    tmp.get(0,1)=sin(alpha);
    tmp.get(1,1)=cos(alpha);

    *this=tmp*current;
    return *this;
  }

  ///
  MatriceTrans &translateX(float trans) throw() {
    MatriceTrans tmp;
    MatriceTrans current(*this);

    tmp.setIdentity();
    tmp.get(0,3)=trans;

    *this=tmp*current;
    return *this;
  }

  ///
  MatriceTrans &translateY(float trans) throw() {
    MatriceTrans tmp;
    MatriceTrans current(*this);

    tmp.setIdentity();
    tmp.get(1,3)=trans;

    *this=tmp*current;
    return *this;
  }
  
  ///
  MatriceTrans &translateZ(float trans) throw() {
    MatriceTrans tmp;
    MatriceTrans current(*this);

    tmp.setIdentity();
    tmp.get(2,3)=trans;

    *this=tmp*current;
    return *this;
  }

  ///
  MatriceTrans &scaleX(float zoom) throw() {
    MatriceTrans tmp;
    MatriceTrans current(*this);

    tmp.setIdentity();
    tmp.get(0,0)=zoom;

    *this=tmp*current;
    return *this;
  }

  ///
  MatriceTrans &scaleY(float zoom) throw() {
    MatriceTrans tmp;
    MatriceTrans current(*this);

    tmp.setIdentity();
    tmp.get(1,1)=zoom;

    *this=tmp*current;
    return *this;
  }

  ///
  MatriceTrans &scaleZ(float zoom) throw() {
    MatriceTrans tmp;
    MatriceTrans current(*this);

    tmp.setIdentity();
    tmp.get(2,2)=zoom;

    *this=tmp*current;
    return *this;
  }

  ///
  MatriceTrans &rotate(float alphaX,float alphaY,float alphaZ) throw() {
    rotateX(alphaX);
    rotateY(alphaY);
    rotateZ(alphaZ);
    return *this;
  }  

  ///
  MatriceTrans &translate(float transX,float transY,float transZ) throw() {
    translateX(transX);
    translateY(transY);
    translateZ(transZ);
    return *this;
  }  

  ///
  MatriceTrans &scale(float f) throw() {
    scale(f,f,f);
    return *this;
  }

  ///
  MatriceTrans &scale(float fX,float fY,float fZ) throw() {
    scaleX(fX);
    scaleY(fY);
    scaleZ(fZ);
    return *this;
  }
};


#include "MatriceTrans.cc"
//useless

#endif
