/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class MessageKeeper;

#ifndef __MessageKeeper_h__
#define __MessageKeeper_h__

#include "List.h"
#include "Key.h"

/**
   Catches keys and analyses if the word is typed : a word is in fact a list of raw key codes.
   When you want that the MessageKeeper manages an action on a word, you must inherite this class and define the function action() : now you can add message to manage (in list of int form).
   With this class, the game can be a shell !!!
   @author David FAUTHOUX
 */
class MessageKeeper {
 protected:
  ///
  class Tcontained {
  public:
    ///
    List< int > mot;
    ///
    int idAction;
    ///
    Tcontained(List< int >& _mot,int idAction)
      :mot(_mot),idAction(idAction) {}
    ///
    ~Tcontained() {}
  };
  ///
  List< Tcontained * > list;

  ///
  void incContained(Tcontained *c) throw(Exception);
  
  ///
  virtual void action(int idAction) throw(Exception)=0;

 public:
  ///
  MessageKeeper() throw();
  ///
  virtual ~MessageKeeper() throw();
  ///Send to this class the keys to manage
  virtual void work(const Key& key) throw(Exception);
 
  //listKey deleted here
  ///The list is a raw key code list, it is deleted here
  virtual void message(List< int >& listKey,int idAction) throw();

};

#endif
