/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class MoreMultiAnim;

#ifndef __MoreMultiAnim_h__
#define __MoreMultiAnim_h__

#include "MultiAnim.h"

// 'MoreMultiAnim' rajoute a 'MultiAnim' le pouvoir de coller des animations,
// en plus, sur celle-ci, qui sont gerees independamment.

/**
   Adds to MultiAnim the power to stick other animations on the current, theese are manage independently.
   Write "id=add(Anim&)" and "onMore(id)".
   See Bonhomme20-invincible
   @author David FAUTHOUX
 */
class MoreMultiAnim:public MultiAnim {
 protected:
  ///
  List< Anim * > animOnMore;
  
  ///
  int virtual virtualWalk() throw();

 public:
  ///
  MoreMultiAnim() throw();
  ///
  virtual ~MoreMultiAnim() throw();

  ///
  void virtual paint(WindowPipe& windowPipe) throw();
  ///
  void virtual paintNight(WindowPipe& windowPipe) throw();
  ///
  void virtual reinit() throw();

  ///Puts the animation on the normal animations. The id is given by MultiAnim on add()
  void virtual onMore(int id) throw (Exception);

  ///The id is given by MultiAnim on add()
  void virtual supprMore(int id) throw (Exception);

  ///
  bool isOn(int id) throw ();
};

#endif
