/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "PageWin95.h"
#include "display.h"

#define DEFAULT_KEY 0

PageWin95::PageWin95(Ini& ini,int numeroSection,
		     GraphicMode& graphicMode,
		     Sounder& sounder,int soundBlowMotId,
		     Keyer& keyer,
		     StripContainer& stripContainer)
  throw(Exception)
  :Page(ini,numeroSection,graphicMode,sounder,soundBlowMotId,stripContainer),
   keyerRef(&keyer),textMode(0),
   text(ini.getList("[Page]",numeroSection,"text","[Page]",numeroSection)),
   text2(ini.getList("[Page]",numeroSection,"text reboot",
		     "[Page]",numeroSection))
{
  for(int k=0;k<NB_KEY_REBOOT;k++) {
    keyReboot[k]=ini.getWithDefaultKey("[Page]",numeroSection,"key reboot",k,
				    DEFAULT_KEY);
    reboot[k]=false;
  }
  text2->place();
  text2->walk();
}

PageWin95::~PageWin95() throw()
{
  if(textMode) delete textMode;
}

void PageWin95::reinit() throw()
{
  if(textMode) return;

  disableGraphic();

  //  keyerRef->keyboardOut();
  textMode=new TextMode();
  //  keyerRef->keyboardIn();

  textMode->on();
  textMode->setBold();
  textMode->setForegroundColor(TextMode::WHITE);
  textMode->setBackgroundColor(TextMode::BLUE);
  textMode->clear();
  textMode->goTo(10,0);

  text->place();
  while(text->walk()) {
    textMode->print(*(text->get()));
    textMode->newLine();
  }

  textMode->refresh();

  for(int k=0;k<NB_KEY_REBOOT;k++) reboot[k]=false;

  text2->place();
  text2->walk();

  Page::reinit();
}

void PageWin95::goOut() throw()
{
  if(!textMode) return;
  //  keyerRef->keyboardOut();
  delete textMode;
  textMode=0;

  enableGraphic();

  //  keyerRef->keyboardIn();
  Page::goOut();
}

void PageWin95::keyAction(const Key& key) throw()
{
  if(!textMode) return;
  for(int k=0;k<3;k++) {
    if(key.getCode()==keyReboot[k]) {
      if(key.isDown()) reboot[k]=true;
      if(key.isUp()) reboot[k]=false;
    }
  }
  bool reb=true;
  for(int k=0;k<3;k++) if(!reboot[k]) { reb=false;break; }
  if(reb) {
    textMode->print(*(text2->get()));
    textMode->newLine();
    textMode->refresh();
    if(!text2->walk()) {
      text2->place();
      text2->walk();
    }
  }
  Page::keyAction(key);
}
