/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class PageWin95;

#ifndef __PageWin95_h__
#define __PageWin95_h__

#include "Page.h"
#include "Ini.h"
#include "Keyer.h"
#include "TextMode.h"

#define NB_KEY_REBOOT 3

/**
   Blue screen !!
   @see TextMode
   @author David FAUTHOUX
 */
class PageWin95:public Page {
 protected:
  ///
  Keyer *keyerRef;
  ///
  TextMode *textMode;
  ///
  int oldMode;
  ///
  List< const String * > *text;
  ///
  List< const String * > *text2;
  ///
  int keyReboot[NB_KEY_REBOOT];
  ///
  bool reboot[NB_KEY_REBOOT];
 public:
  ///
  PageWin95(Ini& ini,int numeroSection,GraphicMode& graphicMode,
	    Sounder& sounder,int soundBlowMotId,Keyer& keyer,
	    StripContainer& stripContainer)
    throw(Exception);
  ///
  virtual ~PageWin95() throw();
  ///
  virtual void reinit() throw();
  ///
  virtual void goOut() throw();
  ///
  virtual void keyAction(const Key& key) throw();
};

#endif
