/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class Painter;

#ifndef __Painter_h__
#define __Painter_h__

#include "PageableContainer.h"
#include "Background.h"
#include "Tji.h"

// gestion d'un 'Background' dans un 'PageableContainer'

/**
   Groups a Background and the PageableContainer concept
   To paint something in a Painter, use add(Pageable&), the Pageable will be managed (and painted) automatically with PageableContainer function and paint() here. The WindowPipe used is the WindowPipe of the Background.
   @see Background
   @author David FAUTHOUX
 */
class Painter:public PageableContainer {
  // private:
  //  void paint(WindowPipe< Pixel >& windowPipe) throw(Exception);//INTERDIT
 protected:
  ///
  Tji posOnScreen;
  ///
  Background *background;
 public:
  ///
  Painter(Background& background,int slow) throw();
  //ATTENTION ! delete du Background fait ici

  ///
  virtual ~Painter() throw ();

  ///
  void virtual paint() throw();
  ///
  void virtual refresh() throw() { background->getWindowPipe()->refreshAll(); }
  
  ///
  void virtual moveOnScreen(int j,int i) throw();
  ///
  void virtual getPosOnScreen(int& j,int& i) const throw();
  ///
  void virtual scroll(int j,int i) throw();

  ///
  void setBackground(Background& back) throw();

};

#endif
