/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class PixelArray;

#ifndef __PixelArray_h__
#define __PixelArray_h__

#include "Array.h"
#include "Pixel.h"
#include "UnderMaskArray.h"

/**
   Uses the c-functions of "mem_function cc"
   @author David FAUTHOUX
   @see Anim
   @see Sprite
 */
class PixelArray:public Array<Pixel> {
 public:
  ///
  PixelArray(Pixel *ref,int size) throw();

  ///
  virtual ~PixelArray() throw() {}

  ///
  void putSprite(const PixelArray& a,const PixelArray& mask,
		 int posFrom,int posTo,int sizeFrom) throw ();
  ///
  void putSpriteColor(Pixel color,const PixelArray& a,
		      int posFrom,int posTo,int sizeFrom) throw ();
  ///
  void putSpriteUnderMask(const PixelArray& a,const PixelArray& mask,
			  int posFrom,int posTo,int sizeFrom,
			  const UnderMaskArray& underMask,int posUnderMask) throw ();
  ///
  void putSpriteUnderMaskPalette(const PixelArray& a,const PixelArray& mask,
				 int posFrom,int posTo,int sizeFrom,
				 const UnderMaskArray& underMask,int posUnderMask,
				 const PixelPalette& pal) throw ();

  ///
  void copy(const PixelArray& a,
		 int posFrom,int posTo,int sizeFrom) throw ();

  ///
  PixelArray& operator=(Pixel pixel) throw();

};

#endif


