/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



/*
  Code of my friend Ulrich ROISSARD - 1999
 */

class Point3D;

#ifndef __Point3D_h__
#define __Point3D_h__

#include "Vector.h"

///
class Point3D : public Vector {
 protected:
  ///
  int s;
  ///
  int t;
public:
  ///
  Point3D() : s(0),t(0) {
  }

  ///
  Point3D(int _s,int _t) : s(_s),t(_t) {
  }

  ///
  ~Point3D() throw() {}

  ///
  Point3D &operator=(const Vector &v) {
    s=t=0;
    for (int i=0;i<3;i++)
      (*this)[i]=v[i];
    return *this;
  }

  ///
  int getS() const {
    return s;
  }

  ///
  int getT() const {
    return t;
  }

  ///
  void setS(int _s) {
    s=_s;
  }

  ///
  void setT(int _t) {
    t=_t;
  }
};

#endif
