/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class SectionAssoc;

#ifndef __SectionAssoc_h__
#define __SectionAssoc_h__

#include "List.h"
#include "ValueString.h"
#include "Exception.h"


// classe utile.
/**
   Used by Ini
   Links a section title to couple (id,value).
   @see Ini
   @author David FAUTHOUX
 */
class SectionAssoc {
 protected:
  ///
  const String title;
  ///
  String com;
  ///
  List< ValueString* > l;
  ///
  bool isUsed;

 public:
  ///
  SectionAssoc(const String& s,const String& comment) throw();
  ///
  ~SectionAssoc() throw();
  ///
  void add(ValueString& v) throw();
  ///
  void set(const String& id,int cpt,const String& val) throw();
  ///
  const String *get(const String& id,int cpt) throw(Exception);
  ///
  const String *getWithoutException(const String& id,int cpt) throw();
  ///
  const String *getWithDefault(const String& id,int cpt,const String& defaut) throw();

  ///
  List< const String* > *getList(const String& id) throw();

  ///
  List< const String* > 
    *getListWithDefaultSection(const String& id,SectionAssoc& other)
    throw(Exception);
  
  ///
  const String *getTitle() const throw();
  ///Usually not used
  const String *getComment() const throw();
  ///
  List< ValueString* > *getAll() throw();

  ///Usually not used
  void setComment(const String& comment) throw();

  ///Used if the .ini files have to be cleaned (to remove the useless sections and ids)
  bool used() const throw() { return isUsed; }

  ///Usually not used : add the id after all the identical ids
  void setWithMaximumNumber(const String& id,const String& val) throw();
};



#endif




