/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include <stdlib.h>
#include "ShakeAnim.h"

ShakeAnim::ShakeAnim(const String& nameFile,int slow,char listSeparator,int jLiberty,int iLiberty)
  throw (Exception)
  :LoopAnim(nameFile,slow,listSeparator)
{
  if(jLiberty<=0) jLiberty=1;
  if(iLiberty<=0) iLiberty=1;
  liberty.j=jLiberty;
  liberty.i=iLiberty;
}

ShakeAnim::ShakeAnim(ShakeAnim& a) throw()
  :LoopAnim(a)
{
  liberty.j=a.liberty.j;
  liberty.i=a.liberty.i;
}

ShakeAnim::~ShakeAnim() throw()
{}

void ShakeAnim::move(int j,int i) throw()
{
  pos.j=normalPos.j=j;
  pos.i=normalPos.i=i;
}

int ShakeAnim::virtualWalk() throw()
{
  pos.j=normalPos.j+rand()%liberty.j;
  pos.i=normalPos.i+rand()%liberty.i;
  return LoopAnim::virtualWalk();
}

