/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class Sprite;

#ifndef __Sprite_h__
#define __Sprite_h__

#include "WindowPipe.h"
//#include "Array3.h"
#include "Pixel.h"
#include "List.h"

//si r et g et b en-deca de cette valeur, alors =0 & translucide
//If r and g and b below this value, then translucent
#define SPRITE_BOUND_LUZ 30

/**
   Links a PixelMatrix to a mask (used to paint quickly with "mem_function cc")
   @author David FAUTHOUX
 */
class Sprite {
 protected:
  ///
  PixelMatrix *data;
  ///
  PixelMatrix *mask;

  ///
  Tji size;

 public:

  ///
  Sprite(int jSize,int iSize) throw ();

  ///
  Sprite(const Sprite& sprite) throw();

  ///
  virtual ~Sprite() throw ();

  ///
  PixelMatrix *getData() throw() { return data; }
  ///
  PixelMatrix *getMask() throw() { return mask; }
  ///
  const PixelMatrix *getData() const throw() { return data; }
  ///
  const PixelMatrix *getMask() const throw() { return mask; }

  ///
  int nbLine() const throw() { return size.j; }
  ///
  int nbColumn() const throw() { return size.i; }

  ///
  void set(int r,int g,int b,int j,int i) throw();
  ///Translucent
  void setLuz(int j,int i) throw();
  ///Never translucent, never shadow
  void setWithoutShadow(int r,int g,int b,int j,int i) throw();

  ///
  void set(Pixel p,int j,int i) throw();

  ///To avoid shadow
  void noTakeLuz() throw();

};


#endif



