/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class String;

#ifndef __String_h__
#define __String_h__

#include "Array.h"
#include "List.h"
#include "Exception.h"

/**
   @author David FAUTHOUX
 */
class String {
 protected:
  ///
  Array< char > *str;
  ///
  virtual int privateToInt(const char *s,bool& withStar) const
    throw();
 public:
  ///
  String() throw();
  ///
  String(const char *s) throw();
  ///
  String(const String& s) throw();
  ///
  String(int i) throw();
  ///
  String(List< char >& l) throw();
  ///
  String& operator=(List< char >& l) throw();
  ///
  String& operator=(const String& s) throw();
  ///
  virtual ~String() throw();
  ///
  virtual int toInt() const throw();
  ///
  virtual int toInt(bool& withStar) const throw();
  ///
  virtual int size() const throw();
  ///
  virtual operator const char*() const throw();
  ///
  virtual operator int() const throw();
  ///
  virtual char operator[](int i) const throw();
  ///
  virtual char& operator[](int i) throw();
  ///
  virtual int operator==(const String& s) const throw();
  ///
  virtual int operator==(const char *s) const throw();
  ///
  virtual String& operator+(const String& s) const throw();
};


#endif
