/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "Strip.h"
#include <iostream.h>
#include <stdlib.h>

Strip::Strip(TextPainter& textPainter,//%%const Font& font,
	     const String& mot,
	     Pixel fontColor,Pixel backgroundColor,
	     int slow,int jBackgroundSize,int iBackgroundSize,
	     int moveStep) throw()
  :Pageable(slow),
   textPainterRef(&textPainter),
   mot(mot),
   fontColor(fontColor),backgroundColor(backgroundColor),
   //%%   line(0),
   moveStep(moveStep)
{
  /*%%%%%%%
  int rf=getRedFromPixel(fontColor);
  int gf=getGreenFromPixel(fontColor);
  int bf=getBlueFromPixel(fontColor);

  int rb=getRedFromPixel(backgroundColor);
  int gb=getGreenFromPixel(backgroundColor);
  int bb=getBlueFromPixel(backgroundColor);

  line=new Sprite(font.nbLine(),mot.size()*font.nbColumn());
  //construire line
  for(int k=0;k<mot.size();k++)
    for(int j=0;j<font.nbLine();j++)
      for(int i=0;i<font.nbColumn();i++)
	if((*(font.get(mot[k])))[j][i]==PIXEL_MASK_FULL)
	  line->set(rf,gf,bf,j,i+k*font.nbColumn());
  	else
	  line->set(rb,gb,bb,j,i+k*font.nbColumn());
  */

  //normal initial move
  //%%  move(rand()%(jBackgroundSize-line->nbLine()),iBackgroundSize);
  move(rand()%(jBackgroundSize-textPainterRef->nbLine()),iBackgroundSize);
}

Strip::~Strip() throw()
{
  //%%  delete line;
}

int Strip::virtualWalk() throw()
{
  //normal move:from right to left
  pos.i-=moveStep;
  //%%  if(pos.i+line->nbColumn()<0) return 0;
  if(pos.i+textPainterRef->nbColumn()*mot.size()<0) return 0;
  return 1;
}

void Strip::paint(WindowPipe& windowPipe) throw()
{
  textPainterRef->paint(windowPipe,pos.j,pos.i,mot,fontColor,backgroundColor);
  //%%  windowPipe.put(*line,pos.j,pos.i);
}

void Strip::reinit() throw()
{
  //normal reinit:go to right
  pos.i=0;
}

void Strip::keyAction(const Key& key) throw()
{
}

void Strip::move(int j,int i) throw()
{
  pos.j=j;
  pos.i=i;
}

void Strip::getPos(int& j,int& i) const throw()
{
  j=pos.j;
  i=pos.i;
}

