/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class Strip;

#ifndef __Strip_h__
#define __Strip_h__

#include "Pageable.h"
#include "Movable.h"
#include "Font.h"
#include "String.h"
//%%#include "Sprite.h"
#include "TextPainter.h"

/**
   A strip is a sentence wich passes on the screen, beginning on the right side, walking to the left side.
   It uses the same laws as Sprite : shadows, translucent color
   @see StripContainer
   @author David FAUTHOUX
*/
class Strip:public Pageable,public Movable {
 protected:
  ///
  TextPainter *const textPainterRef;
  ///
  String mot;
  ///
  Pixel fontColor;
  ///
  Pixel backgroundColor;

  //%%  Sprite *line;

  ///
  const int moveStep;
  ///
  Tji pos;

  ///
  virtual int virtualWalk() throw();
 public:
  ///Usually moveStep=1 
    Strip(TextPainter& textPainter,//%%const Font& font,
	const String& mot,
	Pixel fontColor,
	Pixel backgroundColor,
	int slow,
	int jBackgroundSize,int iBackgroundSize,
	int moveStep) throw();
  ///
  virtual ~Strip() throw();

  ///
  virtual void paint(WindowPipe& windowPipe) throw();
  ///
  virtual void reinit() throw();
  ///
  virtual void keyAction(const Key& key) throw();

  ///
  virtual void move(int j,int i) throw();
  ///
  virtual void getPos(int& j,int& i) const throw();

};

#endif
