/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class StripContainer;

#ifndef __StripContainer_h__
#define __StripContainer_h__

#include "PageableContainer.h"
#include "Font.h"
#include "Ini.h"
#include "Strip.h"
#include "WindowPipe.h"
#include "GraphicMode.h"
#include "Tji.h"
#include "PreStrip.h"
#include "TextPainter.h"

/**
   Manages all Strips of the game. It is an help for the new players.
   It constructs a personal WindowPipe to paint the Strips.
   @see Strip
   @see PreStrip
   @see WindowPipe
   @author David FAUTHOUX
*/
class StripContainer:public PageableContainer {
 protected:
  ///
  TextPainter *const textPainterRef;

  ///
  UnderMaskMatrix underMask;
  ///
  Window *window;
  ///
  WindowPipe *windowPipe;
  ///
  Tji size;

  ///
  int randomSlow;

  /*%%
    Font *font;
    Pixel defaultFontColor;
    Pixel defaultBackgroundColor;
  */

  ///
  int moveStep;

  ///
  PreStrip preStrip;

  ///
  virtual int virtualWalk() throw();

 public:
  ///
  StripContainer(TextPainter& textPainter,Ini& ini,GraphicMode& graphicMode) throw(Exception);
  ///
  virtual ~StripContainer() throw();

  ///
  virtual void add(const String& mot,
		   Pixel fontColor,Pixel backgroundColor) throw();

  //avec couleur par defaut
  ///
  virtual void add(const String& mot,Pixel fontColor) throw();
  ///
  virtual void add(const String& mot) throw();


  ///
  void add(PreStrip::Id mot,Pixel fontColor,Pixel backgroundColor) throw();
  ///
  void add(PreStrip::Id mot,Pixel fontColor) throw();
  ///
  void add(PreStrip::Id mot) throw();


  ///
  virtual void paint() throw();

  ///
  virtual void activate() throw();
};

#endif
