/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class TextMode;

#ifndef __TextMode_h__
#define __TextMode_h__

#include "String.h"
#include "Pixel.h"

/**
   Useful class to write something in text mode, manages colors.
   Uses ANSI codes.
   @author David FAUTHOUX
*/



class TextMode {
 private:
  ///
  bool actif;
  ///
  const int old;

  ///
  void saveState() throw();
  ///
  void restoreState() throw();

  /// (F.)
  Pixel screen[320*200];
  int Bg_col, Fg_col, pos_x, pos_y;

 public:
  ///
  enum ColorId {
    ///
    BLACK=0,
    ///
    RED,
    ///
    GREEN,
    ///
    BROWN,
    ///
    BLUE,
    ///
    MAGENTA,
    ///
    CYAN,
    ///
    WHITE
  };

  ///
  TextMode() throw ();
  ///
  ~TextMode() throw ();
  ///
  void on() throw ();
  ///
  bool isOn() const throw ();
  ///
  void off() throw ();
  ///
  void clear() throw ();
  ///
  void refresh() throw ();
  ///
  void setForegroundColor(ColorId color) throw();
  ///
  void setBackgroundColor(ColorId color) throw();
  ///
  void goTo(int j,int i) throw();
  ///
  void setBold() throw();
  ///
  void unsetBold() throw();
  ///
  void print(const String& s) throw();
  ///
  void newLine() throw();
};


#endif
