/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include <stdlib.h>
#include "Trembleur.h"

int Trembleur::virtualWalk() throw()
{
  if(j>0) j--;
  if(i>0) i--;
  return 1;
}

Trembleur::Trembleur(Tensionable *tensionable) throw()
  :Walkable(0),
   tensionableRef(tensionable)
{
  j=i=0;
}

Trembleur::~Trembleur() throw()
{}

void Trembleur::reinit() throw()
{
  j=i=0;
}

void Trembleur::inc(int j,int i) throw()
{
  if(j>this->j) this->j=j;
  if(i>this->i) this->i=i;
  if(tensionableRef) tensionableRef->incTension(j+i);
}

void Trembleur::get(int& j,int& i) const throw()
{
  int signe=1;
  if(rand()%2) signe=-1;

  if(this->j>0) j=signe*(rand()%(this->j+1));//%%-(this->j/2);
  else j=0;
  if(this->i>0) i=signe*(rand()%(this->i+1));//%%-(this->i/2);
  else i=0;
}
