/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class Trou;

#ifndef __Trou_h__
#define __Trou_h__

#include "MultiAnim.h"
#include "Ini.h"
#include "CounterContainer.h"
#include "Sounder.h"
#include "List.h"
#include "Grille.h"
#include "Tji.h"

// un 'Trou' est un gestionnaire qui pose les animations sur l'ecran (windowTo)
// a intervalle regulier si 'walk' est appele

/**
   Hole.
   When you are dead and irritated !
   The animations are put TO the screen, to avoid shadow.
   Some pixels jumps when a Trou is created.
   @author David FAUTHOUX
 */
class Trou:public MultiAnim,public CounterContainer {
 protected:
  ///
  class Cinq {
  public:
    ///
    int j;
    ///
    int i;
    ///
    int vj;
    ///
    int vi;
    ///
    Sprite *s;
    //%%    Pixel col;
    ///
    Cinq(int _j,int _i,int _vj,int _vi,Pixel _col)
      :j(_j),i(_i),vj(_vj),vi(_vi),s(new Sprite(1,1)) {
      for(int kj=0;kj<s->nbLine();kj++)
	for(int ki=0;ki<s->nbColumn();ki++)
	  s->set(_col,kj,ki);
    }
    ///
    ~Cinq() { delete s; }
  };

  ///
  Tji decal;
  ///
  Tji decalRand;
  ///
  Tji tremble;

  ///
  Sounder *const sounderRef;
  ///
  Grille *const grilleRef;
  ///
  List< Anim * > listToBePaint;
  ///
  Pixel colPixel;
  ///
  int amountPixel;
  ///
  List< Cinq * > listPixel;
  ///
  const int soundId;
  ///
  int cptAnim;

  ///
  virtual int virtualWalk() throw();
  ///
  virtual void endOfCount(int) throw();
  ///
  virtual void walkPixel() throw();
  ///
  virtual void addPixel(int j,int i,Pixel col) throw();
 public:
  ///
  Trou(Ini& ini,Sounder& sounder,Grille& grille) throw(Exception);
  ///
  virtual ~Trou() throw();
  ///To add a hole
  virtual void fire() throw();
  ///
  virtual void paint(WindowPipe& windowPipe) throw();
  ///
  virtual void reinit() throw();
};


#endif
