/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */

#include "UnderMaskMatrix.h"

UnderMaskMatrix::
UnderMaskMatrix(int nbLine_j,int nbColumn_i) throw ()
  :a(nbLine_j)
{
  p=new unsigned char[nbLine_j*nbColumn_i];
  unsigned char *ref=p;
  for(int k=0;k<nbLine();k++) {
    a[k]=new UnderMaskArray(ref,nbColumn_i);
    for(int i=0;i<a[k]->size();i++) (*a[k])[i]=1;
    ref+=nbColumn_i;
  }
}

UnderMaskMatrix::
~UnderMaskMatrix() throw ()
{
  for(int k=0;k<nbLine();k++) delete a[k];
  delete p;
}

UnderMaskArray& 
UnderMaskMatrix::
operator[](int k) throw ()
{
  return *a[k];
}

const UnderMaskArray& 
UnderMaskMatrix::
operator[](int k) const throw ()
{
  return *a[k];
}


int 
UnderMaskMatrix::
nbLine() const throw()
{
  return a.size();
}

int 
UnderMaskMatrix::
nbColumn() const throw()
{
  return a[0]->size();
}


