/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



class Walkable;

#ifndef __Walkable_h__
#define __Walkable_h__

#include "Exception.h"

/**
   This interface enables to slow the derived classes.
   The caller of the object must call the 'walk' method to perform a step in the object progress (pseudo-parallelism).
   The inherited classes must defined virtualWalk() and NOT walk() !
   @author David FAUTHOUX
*/
class Walkable {
 protected:
  ///
  int s;
  ///
  int t;
  ///
  int returnWalk;

  ///
  int virtual virtualWalk() throw(Exception)=0; //return 0 if no more walk up
 public:
  ///Will call virtualWalk() all the "slow" calls to walk()
  Walkable(int slow) throw();

  ///
  virtual ~Walkable() throw() {}

  ///FINAL (Java meaning)
  int /*final*/ walk() throw(Exception);

  ///
  int getSlow() const throw();
  ///
  virtual void setSlow(int slow) throw();
};

#endif

