/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */


#include "List.h"
#include "SDL.h"
#include "SDL_mixer.h"

#define MAX_NB_SOUND 1000
List< int > libre;

bool enableSound( void ) throw()
{
  if( SDL_InitSubSystem( SDL_INIT_AUDIO ) != 0 ) return false;
  Mix_OpenAudio( 11025, (Uint16)AUDIO_U8, 2, 256);

  for(int k=0;k<MAX_NB_SOUND;k++) libre.put(k);
  return true;
}

void disableSound() throw()
{
  //while (Mix_Playing(-1));
  SDL_QuitSubSystem( SDL_INIT_AUDIO );
}

int addSoundFile(const String& nameFile) throw()
{
  libre.place();
  if(!libre.walk()) {
    cerr<<ERROR_NO_PLACE_FOR_NEW_SOUND;
    return -1;
  }
  int i=libre.get();
  libre.suppr();

  i = (int) Mix_LoadWAV( nameFile );
  return i;
}

void supprSound(int id) throw()
{
  Mix_FreeChunk( (Mix_Chunk*)id );
}

void playSound(int id,int channel) throw()
{
  Mix_PlayChannel( -1, (Mix_Chunk*)id, 0 );
}

void setVolumeSound(int id,int volume) throw()
{
/*
  if(Snd_setVolume(id,volume)==EXIT_FAILURE)
    cerr<<ERROR_VOLUME_SOUND;
*/
}

void stopSoundChannel(int channel) throw()
{
/*
  if(Snd_resetChannel(channel)==EXIT_FAILURE)
    cerr<<ERROR_STOP_SOUND_CHANNEL;
*/
}

