/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#include "util.h"
#include "String.h"
#include "Key.h"


bool listToPixel(List< int >& l,Pixel& p) throw()
{
  int rgb[3];
  int cpt=0;
  l.place();
  while(l.walk()) {
    rgb[cpt]=l.get();
    if(cpt==2) {
      p=toPixel(rgb[0],rgb[1],rgb[2],0);
      return true;
    }
    cpt++;
  }
  return false;
}

#include <stdio.h>
bool extractInt(const String& s,char separator,List<int>& l) throw()
{
    int i=0;

    l.place();
    while(i<s.size()) {
      List<char> nb;
      while(i<s.size() && s[i]!=separator) {
	nb.put(s[i]);
	i++;
      }
      String *auxS=new String(nb);
      int aux;
      try {
	aux=auxS->toInt();
      } catch(Exception) {
      aux=0;
      }
      delete auxS;
      l.put(aux);
      i++;
    }

  l.place();
  if(l.walk()) return true;
  return false;
}

bool extractKey(const String& s,char separator,List<int>& l) throw()
{
    l.place();
    for(int k=0;k<s.size();k++)
      {
       char c[2]={s[k],0};
       l.put( getIntForKey(c) );
      }
  l.place();
  if(l.walk()) return true;
  return false;
}



String *downCase(const String& s) throw()
{
  String *ret=new String(s);
  for(int k=0;k<ret->size();k++)
    if((*ret)[k]>='A' && (*ret)[k]<='Z') {
      int c=(*ret)[k];
      c+='a'-'A';
      (*ret)[k]=c;
    }
  return ret;
}


String *simplifyBlank(const String& s) throw()
{
  List<char> list;
  bool blankGap=false;
  bool separatorFound=true;
  for(int i=0;i<s.size();i++) {
    if(isSeparator(s[i])) {
      list.put(s[i]);
      separatorFound=true;
    }
    else if(!isBlank(s[i])) {
      if(blankGap) {
	if(!separatorFound) {
	  list.put(BLANK_SPACE);
	}
	blankGap=false;
      }
      list.put(s[i]);
      separatorFound=false;
    }
    else if(!blankGap) {
      blankGap=true;
    }
  }
  return new String(list);

  /*old
  List<char> list;
  bool blankGap=false;
  for(int i=0;i<s.size();i++) {
    if(!isBlank(s[i])) {
      if(blankGap) {
	if(!list.empty()) list.put(BLANK_SPACE);
	blankGap=false;
      }
      list.put(s[i]);
    }
    else if(!blankGap) {
      blankGap=true;
    }
  }
  return new String(list);
  */
}

/*
  String *supprComment(const String& s) throw()
  {
  List<char> list;
  for(int i=0;i<s.size();i++)
  if(s[i]=='/') {
  if(i+1<s.size()) {
  i++;
  if(s[i]=='/') break;
  else if(s[i]=='*') {
  i++;
  while(i<s.size()) {
  if(s[i]=='*' && i+1<s.size() && s[i+1]==
  i++;
  }
  }
  }
  }
  else {
  if(s[i]=='/')
  }
  if(s[i]!=BLANK_SPACE && s[i]!=BLANK_TAB && s[i]!=BLANK_RETURN) list.put(s[i]);
  return new String(list);
  }
*/
/*%%
  char SEPARATOR[]=" \t\n";
  char SPECIAL_CHAR[]=":{}";

  List<String *> *createWordList(const String& s) throw()
  {
  List<String*> *wordList=new List<String*>;
  List<char> list;
  for(int i=0;i<s.size();i++) {
  bool sep=false;
  int k=0;
  while(SEPARATOR[k]) {
  if(s[i]==SEPARATOR[k]) {
  sep=true;
  break;
  }
  k++;
  }
  
  bool special=false;
  k=0;
  while(SPECIAL_CHAR[k]) {
  if(s[i]==SPECIAL_CHAR[k]) {
  special=true;
  break;
  }
  k++;
  }

  if(special) {
  if(!list.empty()) {
  wordList->put(new String(list));
  list.place();
  while(list.walk()) list.suppr();
  }
  char specialString[2]={s[i],0};
  wordList->put(new String(specialString));
  }
  else if(!sep) list.put(s[i]);
  else if(!list.empty()) {
  wordList->put(new String(list));
  list.place();
  while(list.walk()) list.suppr();
  }
  }
  return wordList;
  }
*/


bool isBlank(char c) throw()
{
  return (c==BLANK_SPACE || c==BLANK_TAB || c==BLANK_RETURN);
}

bool isSeparator(char c) throw()
{
  return (c==SEPARATOR_STAR ||
	  c==SEPARATOR_SLASH ||
	  c==SEPARATOR_AND ||
	  c==SEPARATOR_OPEN_BRACE || c==SEPARATOR_CLOSE_BRACE ||
	  c==SEPARATOR_OPEN_BRACKET || c==SEPARATOR_CLOSE_BRACKET ||
	  c==SEPARATOR_INFERIOR || c==SEPARATOR_SUPERIOR ||
	  c==SEPARATOR_SEMI_COLON || c==SEPARATOR_COLON ||
	  c==SEPARATOR_COMA ||
	  c==SEPARATOR_EQUAL);
}

bool isCapital(char c) throw()
{
  return (c>='A' && c<='Z');
}


  typedef struct { int n; char k[20]; } couple;  // (F.) tool fonc

   couple table[] = {                      // (F.) table to translate key in name and number

    { 0                  , "NULL" }
   ,{ BACKSPACE     , "backspace" }
   ,{ TAB           , "tab" }
   ,{ CLEAR         , "clear" }
   ,{ RETURN        , "return" }
   ,{ PAUSE         , "pause" }
   ,{ ESCAPE        , "escape" }
//   ,{ SPACE         , "space" }
   ,{ SPACE         , " " }
   ,{ EXCLAIM       , "exclaim" }
   ,{ QUOTEDBL      , "quotedbl" }
   ,{ HASH          , "hash" }
   ,{ DOLLAR        , "dollar" }
   ,{ AMPERSAND     , "ampersand" }
   ,{ QUOTE         , "quote" }
   ,{ LEFTPAREN     , "left parenthesis" }
   ,{ RIGHTPAREN    , "right parenthesis" }
   ,{ ASTERISK      , "asterisk" }
   ,{ PLUS          , "plus sign" }
   ,{ COMMA         , "comma" }
   ,{ MINUS         , "minus sign" }
   ,{ PERIOD        , "period" }
   ,{ SLASH         , "forward slash" }
   ,{ K0            , "0" }
   ,{ K1            , "1" }
   ,{ K2            , "2" }
   ,{ K3            , "3" }
   ,{ K4            , "4" }
   ,{ K5            , "5" }
   ,{ K6            , "6" }
   ,{ K7            , "7" }
   ,{ K8            , "8" }
   ,{ K9            , "9" }
   ,{ COLON         , "colon" }
   ,{ SEMICOLON     , "semicolon" }
   ,{ LESS          , "less-than sign" }
   ,{ EQUALS        , "equals sign" }
   ,{ GREATER       , "greater-than sign" }
   ,{ QUESTION      , "question mark" }
   ,{ AT            , "at" }
   ,{ LEFTBRACKET   , "left bracket" }
   ,{ BACKSLASH     , "backslash" }
   ,{ RIGHTBRACKET  , "right bracket" }
   ,{ CARET         , "caret" }
   ,{ UNDERSCORE    , "underscore" }
   ,{ BACKQUOTE     , "grave" }
   ,{ A             , "a" }
   ,{ B             , "b" }
   ,{ C             , "c" }
   ,{ D             , "d" }
   ,{ E             , "e" }
   ,{ F             , "f" }
   ,{ G             , "g" }
   ,{ H             , "h" }
   ,{ I             , "i" }
   ,{ J             , "j" }
   ,{ K             , "k" }
   ,{ L             , "l" }
   ,{ M             , "m" }
   ,{ N             , "n" }
   ,{ O             , "o" }
   ,{ P             , "p" }
   ,{ Q             , "q" }
   ,{ R             , "r" }
   ,{ S             , "s" }
   ,{ T             , "t" }
   ,{ U             , "u" }
   ,{ V             , "v" }
   ,{ W             , "w" }
   ,{ X             , "x" }
   ,{ Y             , "y" }
   ,{ Z             , "z" }
   ,{ DELETE        , "delete" }
   ,{ KP0           , "keypad 0" }
   ,{ KP1           , "keypad 1" }
   ,{ KP2           , "keypad 2" }
   ,{ KP3           , "keypad 3" }
   ,{ KP4           , "keypad 4" }
   ,{ KP5           , "keypad 5" }
   ,{ KP6           , "keypad 6" }
   ,{ KP7           , "keypad 7" }
   ,{ KP8           , "keypad 8" }
   ,{ KP9           , "keypad 9" }
   ,{ KP_PERIOD     , "keypad period" }
   ,{ KP_DIVIDE     , "keypad divide" }
   ,{ KP_MULTIPLY   , "keypad multiply" }
   ,{ KP_MINUS      , "keypad minus" }
   ,{ KP_PLUS       , "keypad plus" }
   ,{ KP_ENTER      , "keypad enter" }
   ,{ KP_EQUALS     , "keypad equals" }
   ,{ UP            , "up arrow" }
   ,{ DOWN          , "down arrow" }
   ,{ RIGHT         , "right arrow" }
   ,{ LEFT          , "left arrow" }
   ,{ INSERT        , "insert" }
   ,{ HOME          , "home" }
   ,{ END           , "end" }
   ,{ PAGEUP        , "page up" }
   ,{ PAGEDOWN      , "page down" }
   ,{ F1            , "F1" }
   ,{ F2            , "F2" }
   ,{ F3            , "F3" }
   ,{ F4            , "F4" }
   ,{ F5            , "F5" }
   ,{ F6            , "F6" }
   ,{ F7            , "F7" }
   ,{ F8            , "F8" }
   ,{ F9            , "F9" }
   ,{ F10           , "F10" }
   ,{ F11           , "F11" }
   ,{ F12           , "F12" }
   ,{ F13           , "F13" }
   ,{ F14           , "F14" }
   ,{ F15           , "F15" }
   ,{ NUMLOCK       , "numlock" }
   ,{ CAPSLOCK      , "capslock" }
   ,{ SCROLLOCK     , "scrollock" }
   ,{ RSHIFT        , "right shift" }
   ,{ LSHIFT        , "left shift" }
   ,{ RCTRL         , "right ctrl" }
   ,{ LCTRL         , "left ctrl" }
   ,{ RALT          , "right alt" }
   ,{ LALT          , "left alt" }
   ,{ RMETA         , "right meta" }
   ,{ LMETA         , "left meta" }
   ,{ LSUPER        , "left windows key" }
   ,{ RSUPER        , "right windows key" }
   ,{ MODE          , "mode shift" }
   ,{ HELP          , "help" }
   ,{ PRINT         , "print-screen" }
   ,{ SYSREQ        , "SysRq" }
   ,{ BREAK         , "break" }
   ,{ MENU          , "menu" }
   ,{ POWER         , "power" }
   ,{ EURO          , "euro" }
   ,{ -1 , "" }
   };


int getIntForKey( const String &key_n ) // tool fonc (F.)
  {
   for( int i=0 ; table[i].n != -1 ; i++ )
     {
      if( strcmp( table[i].k, (const char*)key_n ) == 0 )
        {
          return( table[i].n );
        }
     }

   cerr<<"Key error: "<<(const char*)key_n<<"\n";
   return -1;
  }


const String getKeyForName( int k ) // tool fonc (F.)
  {
   for( int i=0 ; table[i].n != -1 ; i++ )
     {
      if( table[i].n == k )
        {
          return( (String)table[i].k );
        }
     }

   return (String)"Unidentifed Key";
  }


