/* Bomb O Bomb - an entirely transformable game for Linux
 * David FAUTHOUX - July 1999 - email: david.fauthoux@free.fr
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * Modify this soft ! It is made to be original for each player who want it !!
 */



#ifndef __util_h__
#define __util_h__

#include "List.h"
#include "String.h"
#include "Pixel.h"

bool extractInt(const String& s,char separator,List< int >& l) throw();
bool extractKey(const String& s,char separator,List< int >& l) throw();

bool listToPixel(List< int >& l,Pixel& p) throw();



//return must be deleted by the caller
//remplace tous les blanks qui se suivent (ou les blanks tab) par 1 seul BLANK_SPACE
String *simplifyBlank(const String& s) throw();

String *downCase(const String& s) throw();


enum {
  BLANK_SPACE=' ',
  BLANK_TAB='\t',
  BLANK_RETURN='\n'
};
bool isBlank(char c) throw();

enum {
  SEPARATOR_STAR='*',
  SEPARATOR_SLASH='/',
  SEPARATOR_AND='&',
  SEPARATOR_OPEN_BRACE='{',
  SEPARATOR_CLOSE_BRACE='}',
  SEPARATOR_OPEN_BRACKET='(',
  SEPARATOR_CLOSE_BRACKET=')',
  SEPARATOR_INFERIOR='<',
  SEPARATOR_SUPERIOR='>',
  SEPARATOR_SEMI_COLON=';',
  SEPARATOR_COLON=':',
  SEPARATOR_COMA=',',
  SEPARATOR_EQUAL='='
};
bool isSeparator(char c) throw();


bool isCapital(char c) throw();

int getIntForKey( const String &key_n ); // tool fonc (F.) 
const String getKeyForName( int k ); // tool fonc (F.)

#endif
